' from Prop forum, by Johm Abishier
' by H Shanko rev. 9:30 am 28 Feb.2011

CON
  Rxpin = 0
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  #0, lc, fn, caps
OBJ
  tv    : "TV_Text"
  sio   : "FullDuplexSerial"
  vp    : "Conduit"                  ' transfers data to/from PC, 1 cog
  qs    : "QuickSample"              ' captures INA, variables, 1 cog @20 MHz
VAR
  long stack[200], frame[400], char, junk1, junk2, state, idx, outchar
PUB Main 
  vp.register(qs.sampleINA(@frame,1)) 'sample INA w/ 1 cog up to 20 MHz (MUST BE COG 0)
  optional_configure_viewport   ' optionally configure Viewport's interface
  vp.share(@char,@outchar) 'share memory from 'key' to 'id';   END of VP commands <<===  
   
  tv.start(12)
  sio.start(Rxpin,-1,1,9600)
  state := lc
  tv.str(string("  M105 Keypad/Prop I xlator - 1 Mar.2011",13))
  repeat
'    tv.out($00)                 ' clear screen ???
    tv.str(string("Type a char",13))
'    ReadChars
    case state
      lc:
        ReadChars
        if char == $1        ' if 'lc' and 'Fn', 'upper case' (=blue keycap symbols)
          state := fn
        else
          idx := lookdown(char: $10,$11,$12,$13,$6B,$6A,$69,$68,$4F,$4E,$4D,$4C,$28,$29,$2A,$2B,$14,$15,$16,$17,{
          }$01,$67,$66,$65,$64,$4B,$4A,$49,$48,$2C,$2D,$2F,$2E,$18,$19,$19,$1A,$1B,$62,$63)
          outchar := lookup(idx: "qwertyuiopasdfghjklBFzxcvbnmDELDRP  TDMU")
      fn:
        ReadChars
        if char == $19     ' if 'Fn' and 'Space' key, caps (upper-case) mode
          state := caps
        elseif char ==$01 ' if 'Fn' and 'uppercase', 'lc'
          state := lc
        else
          idx := lookdown(char: $10,$11,$12,$13,$6B,$6A,$69,$68,$4F,$4E,$4D,$4C,$28,$29,$2A,$2B,$14,$15,$16,$17,{
          }$01,$67,$66,$65,$64,$4B,$4A,$49,$48,$2C,$2D,$2F,$2E,$18,$19,$19,$1A,$1B,$62,$63)
          outchar := lookup(idx: "1234567890*/+-=:'",$22,"@BF$()?!,.DELDRP  TDMU")
      caps:
        ReadChars
        if char == $1        ' if 'caps' and 'Fn', 'lc'
          state := lc
        else
          idx := lookdown(char: $10,$11,$12,$13,$6B,$6A,$69,$68,$4F,$4E,$4D,$4C,$28,$29,$2A,$2B,$14,$15,$16,$17,{
          }$01,$67,$66,$65,$64,$4B,$4A,$49,$48,$2C,$2D,$2F,$2E,$18,$19,$19,$1A,$1B,$62,$63)
          outchar := lookup(idx: "QWERTYUIOPASDFGHJKLBFZXCVBNMDELDRP  TDMU") 
    tv.str(string(", the character is: "))
    tv.out(outchar) 
    tv.str(string(" = hex "))
    tv.hex(outchar,2)
    tv.out(13)
'    waitcnt(CLKFREQ + cnt)
    
PRI  ReadChars
  char := sio.rx 
  junk1 := sio.rx
  junk2 := sio.rx
  tv.hex(char,2)
  tv.out(32)
  tv.hex(junk1,2)
  tv.out(32)
  tv.hex(junk2,2)
'  tv.out(13)                            
  return
'+-------------------------------------------------------------------------------------+
PUB optional_configure_viewport                                                                                                
  vp.config(string("var:io(bits=[all[0..29],30tx,31rx])"))
  vp.config(string("var:io,key,id")) ' show these VARs
  vp.config(string("lsa:view=io,timescale=200ns,trigger=io[8]f")) ' trig on A8 falling
  vp.config(string("edit:key(default=5,mode=text)"))
  vp.config(string("start:lsa"))                 
'+-------------------------------------------------------------------------------------+